#ifndef __JMCR_DEF_H__
#define __JMCR_DEF_H__

#define JM_SDHC_DEVICE_ID          0x2381
#define JM_MMCHC_DEVICE_ID         0x2382
#define JM_MSHC_DEVICE_ID          0x2383
#define JM_XDHC_DEVICE_ID          0x2384
#define JM_CFHC_DEVICE_ID          0x2368
#define JM_SDHC_DEVICE_ID2          0x2386
#define JM_MMCHC_DEVICE_ID2         0x2387
#define JM_MSHC_DEVICE_ID2          0x2388
#define JM_XDHC_DEVICE_ID2          0x2389

// Sandisk IDs
#define SANDISK_VENDOR_ID          0x0781
#define SANDISK_MSPD_HG_DEVICE_ID  0xB7B5

//SONY IDs
#define SONY_VENDOR_ID             0x104D


// Median/MTRON ID  (Not PCI VENDOR ID...)
#define JMCR_CUSTOMID_MEDIAN       0x4D44414E   
#define JMCR_CUSTOMID_MTRON        0x4D54524E  
#define JMCR_CUSTOMID_ASKA         0x61534B61   
#define JMCR_CUSTOMID_SOHO         0x534F484F  
#define JMCR_CUSTOMID_NONAME       0x4E4F4E65  

#define JM_CLOCK_25MHZ             			25000000  
#define JM_CLOCK_40MHZ             40000000   
#define JM_CLOCK_50MHZ             50000000   
#define JM_CLOCK_60MHZ             60000000  
#define JM_CLOCK_62_5MHZ           62500000   
#define JM_CLOCK_83MHZ             83000000  
#define JM_CLOCK_100MHZ            100000000  
#define JM_CLOCK_125MHZ            125000000 
#define JM_CLOCK_156MHZ            156000000  
#define JM_CLOCK_178MHZ            178000000 
#define JM_CLOCK_208MHZ            208000000  

#define JMCR_POOL_TAG       (unsigned long) 'rCmJ'


// Default DMA Boundary Size 4K
#define JMCR_DEFAULT_BOUNDARY_SIZE      4096 

#define JMCR_CMD_TIMEOUT_TIME           1600  

#define JMCR_CARDIDENTIFY_TIMEOUT_TIME  2500 
#define JMCR_CARDIDENTIFY_RETRY_PERIOD  250  



#define JMCR_MAX_ADAPTERS         5  

#define JMCR_MAX_SLOTS            2  

#define JMCR_MMIO_LENGTH          0x100

//#define JMCR_HC_FIFO_SIZE           512

//#define JMCR_MAX_DMA_BUFFER_SIZE  0x80000L   
//#define JMCR_MAX_DMA_BUFFER_SIZE  0x40000L  
//#define JMCR_MAX_DMA_BUFFER_SIZE  0x10000L  
#define JMCR_MAX_DMA_BUFFER_SIZE  0x1000L   

#define JMCR_MAX_TRANSFER_SIZE    0x200000L  
#define JMCR_CF_MAX_TRANSFER_SIZE 0x100000L  



#define JMCR_MAX_DMA_ENTRY           JMCR_MAX_TRANSFER_SIZE / _4K

#define JMCR_DMA_DESCRIPTOR_SIZE     8   
#define JMCR_DMA_TABLE_SIZE          JMCR_MAX_DMA_ENTRY * JMCR_DMA_DESCRIPTOR_SIZE
#define JMCR_MAX_DMA_DESC_DATA_SIZE  _32K


#define JMCR_DOS_MAX_BLOCK_COUNT     4096

#define JMCR_DEFAULT_IC_DRIVING_380B       	0x03053333
#define JMCR_DEFAULT_IC_DRIVING					0x01020101
#define JMCR_MAX_IC_DRIVING_380B           		0x07077777
#define JMCR_IC_DRIVING_380B_MS_8BIT       0x03073333
#define JMCR_IC_DRIVING_380B_XD            0x04053333
#define JMCR_IC_DRIVING_E4_MASK				0x0000003F
#define JMCR_IC_DRIVING_B8_MASK				0x00C00000
#define JMCR_IC_DRIVING_E4_MASK_380B       0x7FFF0000
#define JMCR_IC_DRIVING_B8_MASK_380B       0x00700000
#define JMADDR_EXTERN_OE       				0xE4

//
// Definitions for HOP_SD_MANUAL_CMD
//

#define SD_MANUAL_CMD_CLASS_STANDARD    0
#define SD_MANUAL_CMD_CLASS_APP_CMD     1

#define SD_MANUAL_CMD_DIR_NONE          0
#define SD_MANUAL_CMD_DIR_READ          1
#define SD_MANUAL_CMD_DIR_WRITE         2

#define SD_MANUAL_CMD_TRANS_NONE        0
#define SD_MANUAL_CMD_TRANS_CMD         1
#define SD_MANUAL_CMD_TRANS_SINGLE_BLK  2
#define SD_MANUAL_CMD_TRANS_MULTI_BLK   3
#define SD_MANUAL_CMD_TRANS_MULTI_BLK_NO_CMD12 4

#define SD_MANUAL_CMD_RESPONSE_UNSPECIFIED  0
#define SD_MANUAL_CMD_RESPONSE_NONE         1
#define SD_MANUAL_CMD_RESPONSE_1            2
#define SD_MANUAL_CMD_RESPONSE_1B           3
#define SD_MANUAL_CMD_RESPONSE_2            4
#define SD_MANUAL_CMD_RESPONSE_3            5
#define SD_MANUAL_CMD_RESPONSE_4            6
#define SD_MANUAL_CMD_RESPONSE_5            7
#define SD_MANUAL_CMD_RESPONSE_5B           8
#define SD_MANUAL_CMD_RESPONSE_6            9
#define SD_MANUAL_CMD_RESPONSE_7            10


// ------------------------------------------------------------------------- //
//                      Timing Delay Definitions                             //
// ------------------------------------------------------------------------- //

#define PCICNFG_REG_TIMING_DELAY       0xB0
#define TIMING_DELAY_BIT_MASK_SLOTA    0x0f00 
#define TIMING_DELAY_SLOTA_SHIFT       8
#define TIMING_DELAY_BIT_MASK_SLOTB    0xf000 
#define TIMING_DELAY_SLOTB_SHIFT       12

#define JMCR_TIMING_DELAY_COUNT        8   
#define JMCR_EXTEND_DELAY_COUNT        6   

// Flags Definition for Adjust Extend Timing Delay Functions
#define ADJUST_CLOCK_DELAY    0x0001
#define ADJUST_CMD_DELAY      0x0002
#define ADJUST_DATA_DELAY     0x0004
#define ADJUST_ENABLE_DLL     0x0010


// ------------------------------------------------------------------------- //
//                      Disk Registry Definitions                            //
// ------------------------------------------------------------------------- //

#define JMCR_DISK_REG_ICON               0x00000001
#define JMCR_DISK_REG_LABEL              0x00000002
#define JMCR_DISK_REG_NO_SOFT_EJECT      0x00000004
#define JMCR_DISK_REG_REMOVAL_POLICY     0x00000008
#define JMCR_DISK_PERHWID_ICON           0x00000100
#define JMCR_DISK_PERHWID_LABEL          0x00000200
#define JMCR_DISK_PERHWID_NO_SOFT_EJECT  0x00000400
#define JMCR_DISK_PERHWID_EN_SOFT_EJECT  0x00000800

#define JMCR_DISK_REG_ALL                0x0000000F
#define JMCR_DISK_PERHWID_ALL            0x00000F00


// ------------------------------------------------------------------------- //
//                        PCI Config Definitions                             //
// ------------------------------------------------------------------------- //
#define JMCR_PCICNFG_JMREV_OFFSET      0xAC
#define JMCR_JMREV_MASK                0x0F  


#define JMCR_BIOS_D3E_ENABLE           0x40  

//
// D3E Setting Register AEh
//
#define JMCR_PCICNFG_D3E_OFFSET_0      0xAE  
#define D3E_MODE_ENABLE                0x08  
#define D3E_WATCH_1394_0               0x10  
#define D3E_WATCH_CARDREADER_0         0x20  

#define JMCR_PCICNFG_D3E_OFFSET_1      0xBE  
#define D3E_WATCH_1394_1               0x04  
#define D3E_WATCH_CARDREADER_1         0x08  

                                            
#define JMCR_PCICNFG_D3E_SLEEP_CNT     0xAD 
                                            


#define JMCR_PCICNFG_PMOS0_OFFSET      0xAE
#define PMOS0_ENABLE                   0x01
#define PMOS0_EN_OVERCURRENT_DEBOUNCE  0x40
#define PMOS0_OVERCURRENT_LEVEL_2_4V   0x06


#define JMCR_PCICNFG_PMOS1_OFFSET      0xBD
#define PMOS1_ENABLE                   0x02
#define PMOS1_EN_OVERCURRENT_DEBOUNCE  0x40
#define PMOS1_OVERCURRENT_LEVEL_2_4V   0x08
#define PMOS1_OVERCURRENT_LEVEL_MASK   0x38


#define JMCR_PCICNFG_PAGESEL_OFFSET    0xBF   
#define JMCR_CFGPAGE_MASK              0xE0
#define JMCR_CFGPAGE_SHIFT             5      
#define JMCR_CFGPAGE_CHIPID            0x01   
#define JMCR_CFGPAGE_ASPM              0x03   
#define JMCR_CFGPAGE_SCRATCH           0x05   
#define JMCR_CFGPAGE_PAD_DELAY_CTRL    0x06   
#define JMCR_CFGPAGE_PAD_DELAY_CTRL2   0x07   

#define JMCR_PCICNFG_PAGE_DATA0_OFFSET 0xE8
#define JMCR_PCICNFG_PAGE_DATA1_OFFSET 0xEC
#define JMCR_PCICNFG_PAGE_DATA2_OFFSET 0xE4



#define JMCR_CFG_P6_EC_DLL_EN_MASK     0x00303FF0 
#define JMCR_CFG_P6_EC_DLL_START       0x00200000 
#define JMCR_CFG_P6_EC_DLL_EN          0x00100000 
#define JMCR_CFG_P6_EC_CLKDLL_EN       0x00002000 
#define JMCR_CFG_P6_EC_CMDDLL_EN       0x00001000 
#define JMCR_CFG_P6_EC_DAT8_11_DLL_EN  0x00000F00 
#define JMCR_CFG_P6_EC_DAT0_3_DLL_EN   0x000000F0 
#define JMCR_CFG_P6_EC_DLL_EN_ALL      0x000030F0 


// ------------------------------------------------------------------------- //
//          PCI Config NIC Share Register Definitions (261,251 Series)       //
// ------------------------------------------------------------------------- //
#define JMCR_NIC_PCICNFG_SHARE_OFFSET_CR   0xF4
#define JMCR_NIC_PCICNFG_SHARE_OFFSET_NIC  0xF5

#define JMCR_CR_READY_FOR_D3E              0x10
#define JMCR_CR_ENTER_D3E                  0x20

#define JMCR_NIC_READY_FOR_D3E             0x10

#endif